' Mini-Cubulus
' (c) 2001 by Andreas Meile, CH-8242 Hofen SH
' e-Mail: andreas@hofen.ch WWW: http://www.hofen.ch/~andreas/

DECLARE SUB DreheRechts (y%)
DECLARE SUB DreheOben (x%)
DECLARE SUB DreheUnten (x%)
DECLARE SUB DreheLinks (y%)
DECLARE SUB ZeichneFeld (x%, y%)

CONST xMaj% = 6
CONST yMaj% = 5
CONST xMin% = 4
CONST yMin% = 3

DIM SHARED f%(xMaj% * xMin% - 1, yMaj% * yMin% - 1), AnzF%

SCREEN 0
WIDTH 40, 25
COLOR 7, 0, 0: CLS

LOCATE 2, 2
PRINT ""; STRING$(xMin%, 196);
FOR x% = 2 TO xMaj%
  PRINT ""; STRING$(xMin%, 196);
NEXT x%
PRINT "";
FOR i% = 1 TO yMin%
  LOCATE 2 + i%, 2
  PRINT "";
  FOR x% = 1 TO xMaj%
    PRINT SPACE$(xMin%); "";
  NEXT x%
NEXT i%
FOR y% = 2 TO yMaj%
  LOCATE 2 + (y% - 1) * (yMin% + 1), 2
  PRINT ""; STRING$(xMin%, 196);
  FOR x% = 2 TO xMaj%
    PRINT ""; STRING$(xMin%, 196);
  NEXT x%
  PRINT "";
  FOR i% = 1 TO yMin%
    LOCATE 2 + (y% - 1) * (yMin% + 1) + i%, 2
    PRINT "";
    FOR x% = 1 TO xMaj%
      PRINT SPACE$(xMin%); "";
    NEXT x%
  NEXT i%
NEXT y%
LOCATE 2 + (yMaj%) * (yMin% + 1), 2
PRINT ""; STRING$(xMin%, 196);
FOR x% = 2 TO xMaj%
  PRINT ""; STRING$(xMin%, 196);
NEXT x%
PRINT "";

' Farblegende, damit man weiss, wie ordnen
FOR x% = 0 TO xMaj% - 1
  COLOR 14 - x%
  LOCATE yMaj% * (yMin% + 1) + 4, 3 + (xMin% + 1) * x%
  PRINT STRING$(xMin%, 97 + x%);
NEXT x%

FOR y% = 0 TO yMaj% - 1
  COLOR , 1 + y%
  FOR i% = 0 TO yMin% - 1
    LOCATE 3 + (yMin% + 1) * y% + i%, xMaj% * (xMin% + 1) + 4
    PRINT " ";
  NEXT i%
NEXT y%

' Feld initialisieren
FOR y% = 0 TO yMaj% * yMin% - 1
  FOR x% = 0 TO xMaj% * xMin% - 1
    f%(x%, y%) = xMaj% * (y% \ yMin%) + x% \ xMin%
    ZeichneFeld x%, y%
  NEXT x%
NEXT y%
AnzF% = 0

d$ = INPUT$(1)

' Mischen
WHILE INKEY$ = ""
  SELECT CASE INT(INT(4! * RND))
  CASE 0
    DreheLinks CINT(INT(CSNG(yMaj% * yMin%) * RND))
  CASE 1
    DreheRechts CINT(INT(CSNG(yMaj% * yMin%) * RND))
  CASE 2
    DreheOben CINT(INT(CSNG(xMaj% * xMin%) * RND))
  CASE 3
    DreheUnten CINT(INT(CSNG(xMaj% * xMin%) * RND))
  END SELECT
WEND

xPos% = 0
yPos% = 0
vert% = 0

DO
  COLOR 8 - 7 * vert%, 0
  LOCATE 1, 3 + xPos% + xPos% \ xMin%
  PRINT CHR$(25);
  LOCATE yMaj% * (yMin% + 1) + 3, 3 + xPos% + xPos% \ xMin%
  PRINT CHR$(24);
  COLOR 15 + 7 * vert%
  LOCATE 3 + yPos% + yPos% \ yMin%, 1
  PRINT CHR$(26);
  LOCATE 3 + yPos% + yPos% \ yMin%, xMaj% * (xMin% + 1) + 3
  PRINT CHR$(27);
  DO
    t$ = INKEY$
  LOOP WHILE t$ = ""
  LOCATE 1, 3 + xPos% + xPos% \ xMin%
  PRINT " ";
  LOCATE yMaj% * (yMin% + 1) + 3, 3 + xPos% + xPos% \ xMin%
  PRINT " ";
  LOCATE 3 + yPos% + yPos% \ yMin%, 1
  PRINT " ";
  LOCATE 3 + yPos% + yPos% \ yMin%, xMaj% * (xMin% + 1) + 3
  PRINT " ";
  SELECT CASE t$
  CASE CHR$(0) + "H"
    IF vert% THEN
      DreheOben xPos%
    ELSE
      yPos% = (yPos% + yMaj% * yMin% - 1) MOD yMaj% * yMin%
    END IF
  CASE CHR$(0) + "K"
    IF vert% THEN
      xPos% = (xPos% + xMaj% * xMin% - 1) MOD xMaj% * xMin%
    ELSE
      DreheLinks yPos%
    END IF
  CASE CHR$(0) + "M"
    IF vert% THEN
      xPos% = (xPos% + 1) MOD xMaj% * xMin%
    ELSE
      DreheRechts yPos%
    END IF
  CASE CHR$(0) + "P"
    IF vert% THEN
      DreheUnten xPos%
    ELSE
      yPos% = (yPos% + 1) MOD yMaj% * yMin%
    END IF
  CASE " "
    vert% = NOT vert%
  END SELECT
LOOP UNTIL AnzF% = 0 OR t$ = CHR$(27)

SUB DreheLinks (y%)
  FOR x% = 0 TO xMin% * xMaj% - 1
    IF f%(x%, y%) <> xMaj% * (y% \ yMin%) + x% \ xMin% THEN
      AnzF% = AnzF% - 1
    END IF
  NEXT x%
  FOR x% = 0 TO xMin% * (xMaj% - 1) - 1
    SWAP f%(x%, y%), f%(x% + xMin%, y%)
  NEXT x%
  FOR x% = 0 TO xMin% * xMaj% - 1
    IF f%(x%, y%) <> xMaj% * (y% \ yMin%) + x% \ xMin% THEN
      AnzF% = AnzF% + 1
    END IF
    ZeichneFeld x%, y%
  NEXT x%
END SUB

SUB DreheOben (x%)
  FOR y% = 0 TO yMin% * yMaj% - 1
    IF f%(x%, y%) <> xMaj% * (y% \ yMin%) + x% \ xMin% THEN
      AnzF% = AnzF% - 1
    END IF
  NEXT y%
  FOR y% = 0 TO yMin% * (yMaj% - 1) - 1
    SWAP f%(x%, y%), f%(x%, y% + yMin%)
  NEXT y%
  FOR y% = 0 TO yMin% * yMaj% - 1
    IF f%(x%, y%) <> xMaj% * (y% \ yMin%) + x% \ xMin% THEN
      AnzF% = AnzF% + 1
    END IF
    ZeichneFeld x%, y%
  NEXT y%
END SUB

SUB DreheRechts (y%)
  FOR x% = 0 TO xMin% * xMaj% - 1
    IF f%(x%, y%) <> xMaj% * (y% \ yMin%) + x% \ xMin% THEN
      AnzF% = AnzF% - 1
    END IF
  NEXT x%
  FOR x% = xMin% * (xMaj% - 1) - 1 TO 0 STEP -1
    SWAP f%(x%, y%), f%(x% + xMin%, y%)
  NEXT x%
  FOR x% = 0 TO xMin% * xMaj% - 1
    IF f%(x%, y%) <> xMaj% * (y% \ yMin%) + x% \ xMin% THEN
      AnzF% = AnzF% + 1
    END IF
    ZeichneFeld x%, y%
  NEXT x%
END SUB

SUB DreheUnten (x%)
  FOR y% = 0 TO yMin% * yMaj% - 1
    IF f%(x%, y%) <> xMaj% * (y% \ yMin%) + x% \ xMin% THEN
      AnzF% = AnzF% - 1
    END IF
  NEXT y%
  FOR y% = yMin% * (yMaj% - 1) - 1 TO 0 STEP -1
    SWAP f%(x%, y%), f%(x%, y% + yMin%)
  NEXT y%
  FOR y% = 0 TO yMin% * yMaj% - 1
    IF f%(x%, y%) <> xMaj% * (y% \ yMin%) + x% \ xMin% THEN
      AnzF% = AnzF% + 1
    END IF
    ZeichneFeld x%, y%
  NEXT y%
END SUB

SUB ZeichneFeld (x%, y%)
  LOCATE 3 + y% + y% \ yMin%, 3 + x% + x% \ xMin%
  COLOR 14 - f%(x%, y%) MOD xMaj%, 1 + f%(x%, y%) \ xMaj%
  PRINT CHR$(97 + f%(x%, y%) MOD xMaj%);
END SUB

